/*
    radio Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "dma.h"
#include "usart.h"
#include "module/mr16.h"
#include "bsp/flash.h"
#include "device/sx1281_driver/radio.h"
#include "device/sx1281_driver/sx1281.h"
#include "module/config.h"
#include "module/mr16.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
MR16_t mr16;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
uint8_t txdata[1];

/* Exported functions ------------------------------------------------------- */
void Task_radio(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / RADIO_FREQ;

  osDelay(RADIO_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
__HAL_UART_ENABLE_IT(&huart2,UART_IT_IDLE);
	MR16_Init(&mr16,&Config_Get()->mr16,MR16_MODE_RC, RADIOMODE_FLRC);
//	mr16.RX_ID[0]=0x1234;
//	BSP_Flash_ReadBytes(0x8000);
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
	  MR16_Main(&mr16, txdata,sizeof(txdata));
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}